/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */


#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "options.h"

#include "prefs.h"
#include "memory.h"

#include "custom.h"
#include "readcpu.h"
#include "newcpu.h"
#include "debug.h"

#include "Memory1.h"
#include "Sony.h"
#include "Screen.h"
#include "Sound.h"

#include "Win32\Win32Port.h"

DWORD WINAPI CPU_Thread(LPVOID *pVoid);
void Quit_vMac(void);

int use_debugger = 0;

void Quit_vMac(void)
{
    StopEmulation=1;

	/*
	  There was a massive memory leak before I
	  put this here!!! Is everyone else blind!?

	  We can't just take 4MB of memory and
	  not give it back when we're done!

	  - Weston
	*/
	RAM_End();

    /* Another one! 3.328MB on systems w/32-bit ints!!! */
    free(table68k);

    return;
}

DWORD WINAPI CPU_Thread(LPVOID *pVoid)
{
   Sleep(500);
   Screen_Refresh();
   m68k_go(1);
   ExitThread(0);
   return 0;
}

int main1(int argc, char **argv)
{
    extern Sound_Ty Sound;
    char CDrootdir[4];
    char CDletter;
    MSG msg;
    PHKEY RegKey;
    PHKEY RegKey2;
    int Temp;
    char AppPath[1024];
    char IconPath[1024];

    StopEmulation=0;

	init_m68k();
	if (custominit() == 0)
	{
        if(thePrefs.DX==1)
         {
           thePrefs.DX=0;
           CreateMainWindow();
           FORWARD_WM_COMMAND(MainWnd, ID_FILE_DIRECTX, NULL, 0, PostMessage);
         }
        else
         {CreateMainWindow();}

                if(thePrefs.FileIcons==1)
                {
                    GetModuleFileName(NULL,AppPath,1000);

                    //Give DSK files an icon
                    strcpy(IconPath,AppPath);
                    strcpy(&IconPath[strlen(IconPath)],",1\0");

                    RegCreateKeyEx(HKEY_CLASSES_ROOT,".DSK\0", 0, "vMac",REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,&RegKey,NULL);
                    RegSetValueEx(RegKey,NULL,0,REG_SZ,"vMac DSK\0",9);
                    RegCloseKey(RegKey);

                    RegCreateKeyEx(HKEY_CLASSES_ROOT,"vMac DSK\0", 0, "vMac",REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,&RegKey,NULL);
                    RegSetValueEx(RegKey,NULL,0,REG_SZ,"vMac Disk Image\0",16);

                    RegCreateKeyEx(RegKey,"DefaultIcon", 0, "vMac",REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,&RegKey2,NULL);
                    RegSetValueEx(RegKey2,NULL,0,REG_SZ,IconPath,strlen(IconPath)+1);
                    RegCloseKey(RegKey);
                    RegCloseKey(RegKey2);

                    //Give ROM files an icon
                    strcpy(IconPath,AppPath);
                    strcpy(&IconPath[strlen(IconPath)],",2\0");

                    RegCreateKeyEx(HKEY_CLASSES_ROOT,".ROM\0", 0, "vMac",REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,&RegKey,NULL);
                    RegSetValueEx(RegKey,NULL,0,REG_SZ,"vMac ROM\0",9);
                    RegCloseKey(RegKey);

                    RegCreateKeyEx(HKEY_CLASSES_ROOT,"vMac ROM\0", 0, "vMac",REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,&RegKey,NULL);
                    RegSetValueEx(RegKey,NULL,0,REG_SZ,"ROM Image\0",15);

                    RegCreateKeyEx(RegKey,"DefaultIcon", 0, "vMac",REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,&RegKey2,NULL);
                    RegSetValueEx(RegKey2,NULL,0,REG_SZ,IconPath,strlen(IconPath)+1);
                    RegCloseKey(RegKey);
                    RegCloseKey(RegKey2);
                }

		Screen_Init();
		m68k_reset();

        if(thePrefs.CD!=0)
        {
           //Make sure that there is a CD-ROM drive
           for(CDletter = 'C'; CDletter <= 'Z'; CDletter++)
             {
               wsprintf(CDrootdir, "%c:\\", CDletter);
               if(GetDriveType(CDrootdir) == DRIVE_CDROM)
               {
                    // Found it
                    CDdrive=CDletter-'A';
                    CDinit();
                    break;
               }
             }
        }

        if(thePrefs.Floppy!=0)
         {
          UseFloppy=1;
          dinit();
         }

        WaveInit();

        hThread_CPU=CreateThread(NULL, 0, CPU_Thread, NULL, 0, &iThread_CPUID);
        SetThreadPriority(hThread_CPU, THREAD_PRIORITY_NORMAL);

        SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_ABOVE_NORMAL);

        while (!StopEmulation)
         {
            GetMessage(&msg,NULL,0,0);
    	    Win32WMProc(msg.hwnd, msg.message, msg.wParam, msg.lParam);
         }

        vMacError=0;
	}
	else
	{
	    vMacError=1;
		vMac_Message("Sorry, vMac encountered errors and cannot continue.\n");
	}

        PrefsSave(PrefsFile);

    Quit_vMac();

	return (0);
}
